diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDye.java b/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
index aa53bac2e..48d97f4e0 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
@@ -18,6 +18,7 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.type.WorldTypes;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -38,7 +39,7 @@ public class ItemDye extends Item {
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xPlaced, double yPlaced) {
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xPlaced, double yPlaced) {
         Block<?> block = world.getBlock(blockPos);
         if (Block.hasLogicClass(block, BlockLogicSign.class) && world.getTileEntity(blockPos) instanceof TileEntitySign sign) {
             if ((DyeColor.WHITE.itemMeta - selfStack.getMetadata()) != sign.getColor().id) {
@@ -50,39 +51,35 @@ public class ItemDye extends Item {
             }
             return false;
         }
-        if(selfStack.getMetadata() == DyeColor.WHITE.itemMeta) {
-            if (Block.getLogicClass(block) instanceof IBonemealable bonemealable){
-                if (bonemealable.onBonemealUsed(selfStack, player, world, blockPos, side, xPlaced, yPlaced)){
+        if (selfStack.getMetadata() == DyeColor.WHITE.itemMeta) {
+            TilePos queryPos = new TilePos();
+
+            if (Block.getLogicClass(block) instanceof IBonemealable bonemealable) {
+                if (bonemealable.onBonemealUsed(selfStack, player, world, blockPos, side, xPlaced, yPlaced)) {
                     return true;
                 }
             }
-            if(block == Blocks.DIRT)
-            {
-                if(!world.isClientSide)
-                {
-                    if(Blocks.lightBlock[world.getBlockId(blockPos.up())] <= 2) {
+            if (block == Blocks.DIRT) {
+                if (!world.isClientSide) {
+                    if (Blocks.lightBlock[world.getBlockId(blockPos.up(queryPos))] <= 2) {
                         int grass = Blocks.GRASS.id();
-                        if(world.dimensionData.getWorldType() == WorldTypes.OVERWORLD_RETRO) {
+                        if (world.dimensionData.getWorldType() == WorldTypes.OVERWORLD_RETRO) {
                             grass = Blocks.GRASS_RETRO.id();
                         }
                         world.setBlockIdNotify(blockPos, grass);
-                        if (player == null || player.getGamemode().consumeBlocks())
-                        {
+                        if (player == null || player.getGamemode().consumeBlocks()) {
                             selfStack.stackSize--;
                         }
                     }
                 }
                 return true;
             }
-            if(block == Blocks.DIRT_SCORCHED)
-            {
-                if (!world.isClientSide)
-                {
-                    if(Blocks.lightBlock[world.getBlockId(blockPos.up())] <= 2) {
+            if (block == Blocks.DIRT_SCORCHED) {
+                if (!world.isClientSide) {
+                    if (Blocks.lightBlock[world.getBlockId(blockPos.up(queryPos))] <= 2) {
                         int grass = Blocks.GRASS_SCORCHED.id();
                         world.setBlockIdNotify(blockPos, grass);
-                        if (player == null || player.getGamemode().consumeBlocks())
-                        {
+                        if (player == null || player.getGamemode().consumeBlocks()) {
                             selfStack.stackSize--;
                         }
                     }
@@ -90,39 +87,31 @@ public class ItemDye extends Item {
                 return true;
             }
 
-            if(block != null && block.hasTag(BlockTags.GROWS_FLOWERS))
-            {
-                if(!world.isClientSide)
-                {
-                    if (player == null || player.getGamemode().consumeBlocks())
-                    {
+            if (block != null && block.hasTag(BlockTags.GROWS_FLOWERS)) {
+                if (!world.isClientSide) {
+                    if (player == null || player.getGamemode().consumeBlocks()) {
                         selfStack.stackSize--;
                     }
                     TilePos p = new TilePos(blockPos);
                     label0:
-                    for(int j1 = 0; j1 < 128; j1++)
-                    {
-                        p.set(blockPos.x, blockPos.y + 1, blockPos.z);
-                        for(int j2 = 0; j2 < j1 / 16; j2++)
-                        {
+                    for (int j1 = 0; j1 < 128; j1++) {
+                        p.set(blockPos.x(), blockPos.y() + 1, blockPos.z());
+                        for (int j2 = 0; j2 < j1 / 16; j2++) {
                             p.x += itemRand.nextInt(3) - 1;
                             p.y += ((itemRand.nextInt(3) - 1) * itemRand.nextInt(3)) / 2;
                             p.z += itemRand.nextInt(3) - 1;
-                            int id1 = world.getBlockId(p.down());
-                            if(Blocks.blocksList[id1] == null || !Blocks.blocksList[id1].hasTag(BlockTags.GROWS_FLOWERS))
-                            {
+                            int id1 = world.getBlockId(p.down(queryPos));
+                            if (Blocks.blocksList[id1] == null || !Blocks.blocksList[id1].hasTag(BlockTags.GROWS_FLOWERS)) {
                                 continue label0;
                             }
                         }
 
-                        if(world.getBlockId(p) != 0)
-                        {
+                        if (world.getBlockId(p) != 0) {
                             continue;
                         }
-                        if(itemRand.nextInt(10) != 0)
-                        {
-                            if(world.getBlockId(p.down()) == Blocks.DIRT_SCORCHED.id() ||
-                                    world.getBlockId(p.down()) == Blocks.DIRT_SCORCHED_RICH.id())
+                        if (itemRand.nextInt(10) != 0) {
+                            if (world.getBlockId(p.down(queryPos)) == Blocks.DIRT_SCORCHED.id() ||
+                                world.getBlockId(p.down(queryPos)) == Blocks.DIRT_SCORCHED_RICH.id())
                                 world.setBlockIdNotify(p, Blocks.SPINIFEX.id());
                             else
                                 world.setBlockIdNotify(p, Blocks.TALLGRASS.id());
@@ -130,7 +119,7 @@ public class ItemDye extends Item {
                         }
                         int r = itemRand.nextInt(12);
                         Biome biome = world.getBlockBiome(p);
-                        if (r < 1){
+                        if (r < 1) {
                             world.setBlockIdNotify(p, Blocks.FLOWER_YELLOW.id());
                         } else if (r < 2) {
                             world.setBlockIdNotify(p, Blocks.FLOWER_RED.id());
@@ -152,15 +141,15 @@ public class ItemDye extends Item {
     }
 
     @Override
-    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePos blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        onUseOnBlock(selfStack, world, null, blockPos.add(direction), direction.getSide(), 0.5, 0.5);
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        onUseOnBlock(selfStack, world, null, blockPos.add(direction, new TilePos()), direction.getSide(), 0.5, 0.5);
     }
 
     @Override
     public boolean useOnEntity(@NotNull ItemStack selfStack, @NotNull Player player, @NotNull Mob mob) {
-        if(mob instanceof MobSheep mobSheep) {
+        if (mob instanceof MobSheep mobSheep) {
             DyeColor woolColor = DyeColor.colorFromItemMeta(selfStack.getMetadata());
-            if(mobSheep.getFleeceColor() != woolColor && selfStack.consumeItem(player)) {
+            if (mobSheep.getFleeceColor() != woolColor && selfStack.consumeItem(player)) {
                 mobSheep.setFleeceColor(woolColor);
                 return true;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemEgg.java b/game/core/src/main/java/net/minecraft/core/item/ItemEgg.java
index 99fc35109..7b08f9f97 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemEgg.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemEgg.java
@@ -5,7 +5,7 @@ import net.minecraft.core.entity.projectile.ProjectileEgg;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -22,15 +22,15 @@ public class ItemEgg extends Item implements IDispensable {
     public @Nullable ItemStack onUse(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Player player) {
         selfStack.consumeItem(player);
         world.playSoundAtEntity(player, player, "random.bow", 0.5F, 0.4F / (itemRand.nextFloat() * 0.4F + 0.8F));
-        if(!world.isClientSide) {
+        if (!world.isClientSide) {
             world.entityJoinedWorld(new ProjectileEgg(world, player));
         }
         return selfStack;
     }
 
     @Override
-    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePos blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        ProjectileEgg projectileEgg = new ProjectileEgg(world, blockPos.x + offX, blockPos.y + offY, blockPos.z + offZ);
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        ProjectileEgg projectileEgg = new ProjectileEgg(world, blockPos.x() + offX, blockPos.y() + offY, blockPos.z() + offZ);
         projectileEgg.setHeading(direction.getOffsetX() * 0.6, direction.getOffsetY() == 0 ? 0.1 : direction.getOffsetY() * 0.6, direction.getOffsetZ() * 0.6f, 1.1F, 6F);
         world.entityJoinedWorld(projectileEgg);
         selfStack.stackSize -= 1;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java b/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java
index a78f44def..528e97afb 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java
@@ -13,6 +13,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -23,15 +24,15 @@ public class ItemFireStriker extends Item {
     public ItemFireStriker(@NotNull String name, @NotNull String namespaceId, int id) {
         super(name, namespaceId, id);
         this.maxStackSize = 1;
-        setMaxDamage(ToolMaterial.iron.getDurability()/2);
+        setMaxDamage(ToolMaterial.iron.getDurability() / 2);
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
-        blockPos = blockPos.add(side.getDirection());
-        if(world.isAirBlock(blockPos)) {
-            if(world.setBlockIdNotify(blockPos, Blocks.FIRE.id())){
-                world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) blockPos.x + 0.5D, (double) blockPos.y + 0.5D, (double) blockPos.z + 0.5D, "fire.ignite", 1.0F, itemRand.nextFloat() * 0.4F + 0.8F);
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
+        blockPos = blockPos.add(side.getDirection(), new TilePos());
+        if (world.isAirBlock(blockPos)) {
+            if (world.setBlockIdNotify(blockPos, Blocks.FIRE.id())) {
+                world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) blockPos.x() + 0.5D, (double) blockPos.y() + 0.5D, (double) blockPos.z() + 0.5D, "fire.ignite", 1.0F, itemRand.nextFloat() * 0.4F + 0.8F);
                 selfStack.damageItem(1, player);
                 return true;
             }
@@ -41,20 +42,21 @@ public class ItemFireStriker extends Item {
     }
 
     @Override
-    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePos blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
         if (!onUseOnBlock(selfStack, world, null, blockPos, direction.getSide(), 0.5, 0.5)) {
-            blockPos = blockPos.add(direction);
+            blockPos = blockPos.add(direction, new TilePos());
+            TilePos queryPos = new TilePos();
             Block<?> b = world.getBlock(blockPos);
             if (Block.getLogicClass(b) instanceof BlockLogicBrazier brazier && brazier.isBurning()) {
-                if (Block.hasLogicClass(world.getBlock(blockPos.east()), BlockLogicFluid.class) ||
-                    Block.hasLogicClass(world.getBlock(blockPos.west()), BlockLogicFluid.class) ||
-                    Block.hasLogicClass(world.getBlock(blockPos.south()), BlockLogicFluid.class) ||
-                    Block.hasLogicClass(world.getBlock(blockPos.north()), BlockLogicFluid.class)) {
+                if (Block.hasLogicClass(world.getBlock(blockPos.east(queryPos)), BlockLogicFluid.class) ||
+                    Block.hasLogicClass(world.getBlock(blockPos.west(queryPos)), BlockLogicFluid.class) ||
+                    Block.hasLogicClass(world.getBlock(blockPos.south(queryPos)), BlockLogicFluid.class) ||
+                    Block.hasLogicClass(world.getBlock(blockPos.north(queryPos)), BlockLogicFluid.class)) {
                     return;
                 }
                 world.setBlockIdDataNotify(blockPos, Blocks.BRAZIER_ACTIVE.id(), 0);
                 selfStack.damageItem(1, null);
-                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) blockPos.x + 0.5D, (double) blockPos.y + 0.5D, (double) blockPos.z + 0.5D, "fire.ignite", 1.0F, world.rand.nextFloat() * 0.4F + 0.8F);
+                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) blockPos.x() + 0.5D, (double) blockPos.y() + 0.5D, (double) blockPos.z() + 0.5D, "fire.ignite", 1.0F, world.rand.nextFloat() * 0.4F + 0.8F);
             } else if (Block.getLogicClass(b) instanceof BlockLogicTNT tnt) {
                 tnt.ignite(world, new TilePos(blockPos), true);
             }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java b/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java
index 7522667ca..1289b5f73 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java
@@ -12,6 +12,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -23,14 +24,14 @@ public class ItemFlag extends Item {
 
     @Override
     public @NotNull String getLanguageKey(@NotNull ItemStack selfStack) {
-    	if(hasFlagBeenDrawnOn(selfStack) || doesFlagContainDyes(selfStack)) {
-    		return getKey() + ".modified";
-    	}
+        if (hasFlagBeenDrawnOn(selfStack) || doesFlagContainDyes(selfStack)) {
+            return getKey() + ".modified";
+        }
         return super.getLanguageKey(selfStack);
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
         // copy flag data to empty flag
         if (world.getBlockId(blockPos) == Blocks.FLAG.id() && player != null && !player.isSneaking()) {
             if (world.getTileEntity(blockPos) instanceof TileEntityFlag flag) {
@@ -47,29 +48,29 @@ public class ItemFlag extends Item {
             }
         }
 
-        if(side == Side.BOTTOM) {
+        if (side == Side.BOTTOM) {
             return false;
         }
 
-        if(!world.getBlockMaterial(blockPos).isSolid()) {
+        if (!world.getBlockMaterial(blockPos).isSolid()) {
             return false;
         }
 
-        if(!world.canPlaceInsideBlock(blockPos)) {
-            blockPos = blockPos.add(side.getDirection());
+        if (!world.canPlaceInsideBlock(blockPos)) {
+            blockPos = blockPos.add(side.getDirection(), new TilePos());
         }
-        if(blockPos.y < 0 || blockPos.y >= world.getHeightBlocks()) {
+        if (blockPos.y() < 0 || blockPos.y() >= world.getHeightBlocks()) {
             return false;
         }
-        if(!Blocks.SIGN_POST_PLANKS_OAK.canPlaceAt(world, blockPos)) {
+        if (!Blocks.SIGN_POST_PLANKS_OAK.canPlaceAt(world, blockPos)) {
             return false;
         }
 
-        world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, Blocks.FLAG, EnumBlockSoundEffectType.PLACE);
+        world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.FLAG, EnumBlockSoundEffectType.PLACE);
         world.setBlockIdDataNotify(blockPos, Blocks.FLAG.id(), 0);
 
         selfStack.consumeItem(player);
-        if(world.getTileEntity(blockPos) instanceof TileEntityFlag flag) {
+        if (world.getTileEntity(blockPos) instanceof TileEntityFlag flag) {
             CompoundTag flagData = selfStack.getData().getCompoundOrDefault("FlagData", null);
             if (flagData != null) {
                 flag.readAdditionalData(flagData);
@@ -83,32 +84,32 @@ public class ItemFlag extends Item {
     }
 
     public boolean hasFlagBeenDrawnOn(@NotNull ItemStack selfStack) {
-    	CompoundTag flagData = selfStack.getData().getCompound("FlagData");
-    	if(flagData == null) {
-    		return false;
-    	}
-
-    	byte[] colors = flagData.getByteArray("Colors");
-    	if(colors == null) {
-    		return false;
-    	}
-
-    	for(int i=0; i < colors.length; i++) {
-    		if(colors[i] != 0) {
-    			return true;
-    		}
-    	}
-    	
-    	return false;
+        CompoundTag flagData = selfStack.getData().getCompound("FlagData");
+        if (flagData == null) {
+            return false;
+        }
+
+        byte[] colors = flagData.getByteArray("Colors");
+        if (colors == null) {
+            return false;
+        }
+
+        for (int i = 0; i < colors.length; i++) {
+            if (colors[i] != 0) {
+                return true;
+            }
+        }
+
+        return false;
     }
-    
+
     public boolean doesFlagContainDyes(@NotNull ItemStack selfStack) {
-    	CompoundTag flagData = selfStack.getData().getCompound("FlagData");
-    	if(flagData == null) {
-    		return false;
-    	}
-    	
-    	ListTag items = flagData.getList("Items");
-    	return items != null && items.tagCount() > 0;
+        CompoundTag flagData = selfStack.getData().getCompound("FlagData");
+        if (flagData == null) {
+            return false;
+        }
+
+        ListTag items = flagData.getList("Items");
+        return items != null && items.tagCount() > 0;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemJar.java b/game/core/src/main/java/net/minecraft/core/item/ItemJar.java
index 9e2a44396..f1327289c 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemJar.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemJar.java
@@ -5,11 +5,13 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.animal.MobButterfly;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
 
 import java.util.List;
 
@@ -21,14 +23,14 @@ public class ItemJar extends ItemPlaceable {
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
         if (player != null && player.isSneaking()) {
             return super.onUseOnBlock(selfStack, world, player, blockPos, side, xHit, yHit);
         }
         if (player != null) {
             int count = selfStack.stackSize;
             ItemStack used = onUse(selfStack, world, player);
-            if (used != null && used.stackSize != count){
+            if (used != null && used.stackSize != count) {
                 return true;
             }
         }
@@ -40,29 +42,26 @@ public class ItemJar extends ItemPlaceable {
         if (player.isSneaking()) {
             return selfStack;
         }
-        List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(player,player.bb.grow(2, 2, 2));
+        List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(player, MathHelper.aabbGrow(player.bb, 2, 2, 2, new AABBd()));
 
-        for(Entity entity : list){
-            if(entity instanceof MobFireflyCluster fireflyCluster) {
+        for (Entity entity : list) {
+            if (entity instanceof MobFireflyCluster fireflyCluster) {
                 MobFireflyCluster.FireflyColor colour = fireflyCluster.getColor();
 
                 boolean didFillJar;
-                if(colour == MobFireflyCluster.FireflyColor.BLUE){
+                if (colour == MobFireflyCluster.FireflyColor.BLUE) {
                     didFillJar = fillJar(player, new ItemStack(Items.LANTERN_FIREFLY_BLUE, 1));
-                }
-                else if(colour == MobFireflyCluster.FireflyColor.ORANGE){
+                } else if (colour == MobFireflyCluster.FireflyColor.ORANGE) {
                     didFillJar = fillJar(player, new ItemStack(Items.LANTERN_FIREFLY_ORANGE, 1));
-                }
-                else if(colour == MobFireflyCluster.FireflyColor.RED){
+                } else if (colour == MobFireflyCluster.FireflyColor.RED) {
                     didFillJar = fillJar(player, new ItemStack(Items.LANTERN_FIREFLY_RED, 1));
-                }
-                else{
+                } else {
                     didFillJar = fillJar(player, new ItemStack(Items.LANTERN_FIREFLY_GREEN, 1));
                 }
 
-                if(!world.isClientSide && didFillJar) {
+                if (!world.isClientSide && didFillJar) {
                     fireflyCluster.setFireflyCount(fireflyCluster.getFireflyCount() - 1);
-                    if(fireflyCluster.getFireflyCount() <= 0) {
+                    if (fireflyCluster.getFireflyCount() <= 0) {
                         fireflyCluster.remove();
                     }
                 }
@@ -73,7 +72,7 @@ public class ItemJar extends ItemPlaceable {
 
                 boolean didFillJar = fillJar(player, new ItemStack(color.jarItem.get(), 1));
 
-                if(!world.isClientSide && didFillJar) {
+                if (!world.isClientSide && didFillJar) {
                     butterfly.remove();
                 }
 
@@ -85,12 +84,12 @@ public class ItemJar extends ItemPlaceable {
 
     public static boolean fillJar(@NotNull Player player, @NotNull ItemStack itemToGive) {
         ItemStack currentItem = player.inventory.getCurrentItem();
-        if(currentItem == null || currentItem.stackSize <= 1) {
+        if (currentItem == null || currentItem.stackSize <= 1) {
             player.inventory.setItem(player.inventory.getCurrentItemIndex(), itemToGive);
         } else {
-        	player.inventory.insertItem(itemToGive, true);
+            player.inventory.insertItem(itemToGive, true);
         }
-        if(itemToGive.stackSize < 1) {
+        if (itemToGive.stackSize < 1) {
             player.swingItem();
             player.inventory.getCurrentItem().consumeItem(player);
             return true;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemLabel.java b/game/core/src/main/java/net/minecraft/core/item/ItemLabel.java
index cdc1befc8..4a3831aa0 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemLabel.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemLabel.java
@@ -6,11 +6,13 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Direction;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.List;
 import java.util.Random;
@@ -21,44 +23,44 @@ public class ItemLabel extends Item {
         setMaxStackSize(1);
     }
 
-	@Override
-	public @Nullable ItemStack onUse(final @NotNull ItemStack selfStack, final @NotNull World world, final @NotNull Player player) {
-		if(selfStack.hasCustomName()) {
-			return selfStack;
-		}
-		
-		int slot = -1;
+    @Override
+    public @Nullable ItemStack onUse(final @NotNull ItemStack selfStack, final @NotNull World world, final @NotNull Player player) {
+        if (selfStack.hasCustomName()) {
+            return selfStack;
+        }
 
-		// Get inventory slot
-		for(int i = 0; i < player.inventory.mainInventory.length; i++) {
-			if(player.inventory.mainInventory[i] == selfStack) {
-				slot = i;
-				break;
-			}
-		}
+        int slot = -1;
 
-		if(slot != -1) {
-			player.displayLabelEditorScreen(selfStack, slot);
-		}
-		return selfStack;
-	}
+        // Get inventory slot
+        for (int i = 0; i < player.inventory.mainInventory.length; i++) {
+            if (player.inventory.mainInventory[i] == selfStack) {
+                slot = i;
+                break;
+            }
+        }
 
-	@Override
-	public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePos blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-		String customName = selfStack.getCustomName();
-		if (customName == null) return;
-		blockPos = blockPos.add(direction);
-		AABB box = AABB.fromPool(blockPos.x, blockPos.y, blockPos.z, blockPos.x + 1, blockPos.y + 1, blockPos.z + 1);
-		List<Entity> entities = world.getEntitiesWithinAABBExcludingEntity(null, box);
-		for (Entity entity : entities) {
-			if (entity instanceof Player) continue;
-			if (entity instanceof Mob mob && !entity.hadNicknameSet) {
-				if (selfStack.hasCustomColor()) {
-					mob.chatColor = selfStack.getCustomColor();
-				}
-				mob.setNickname(StringUtils.substring(customName, 0, 32));
-				break;
-			}
-		}
-	}
+        if (slot != -1) {
+            player.displayLabelEditorScreen(selfStack, slot);
+        }
+        return selfStack;
+    }
+
+    @Override
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        String customName = selfStack.getCustomName();
+        if (customName == null) return;
+        blockPos = blockPos.add(direction, new TilePos());
+        AABBdc box = new AABBd(blockPos.x(), blockPos.y(), blockPos.z(), blockPos.x() + 1, blockPos.y() + 1, blockPos.z() + 1);
+        List<Entity> entities = world.getEntitiesWithinAABBExcludingEntity(null, box);
+        for (Entity entity : entities) {
+            if (entity instanceof Player) continue;
+            if (entity instanceof Mob mob && !entity.hadNicknameSet) {
+                if (selfStack.hasCustomColor()) {
+                    mob.chatColor = selfStack.getCustomColor();
+                }
+                mob.setNickname(StringUtils.substring(customName, 0, 32));
+                break;
+            }
+        }
+    }
 }
